import { Five9Types } from '../../types/five9Types';

export declare class Five9Manager {
    #private;
    private readonly _emitter;
    readonly on: {
        <Key extends string | number | symbol>(type: Key, handler: import('mitt').Handler<any>): void;
        (type: "*", handler: import('mitt').WildcardHandler<any>): void;
    };
    readonly off: {
        <Key extends string | number | symbol>(type: Key, handler?: import('mitt').Handler<any> | undefined): void;
        (type: "*", handler: import('mitt').WildcardHandler<any>): void;
    };
    conversationStarted: boolean;
    private five9WebSocket?;
    serialize(): string;
    static deserialize(rawData: string): Five9Manager;
    static generateBaseUrl(host: string): string;
    createSession(): Promise<Five9Types.SessionToken>;
    setSession(sessionToken: Five9Types.SessionToken): void;
    setConversationId(conversationId: string): void;
    connect(): void;
    connectToWebSocket(): void;
    authenticatedFetch(path: string, options?: RequestInit): Promise<any>;
    getMetadata(): Promise<Five9Types.SessionToken>;
    createConversation(conversation: Partial<Five9Types.Conversation>): Promise<Five9Types.ConversationInfo>;
    sendMessage(content: string): Promise<void>;
    sendTyping(): Promise<void>;
    acknowledgeMessage(messages: Five9Types.AcknowledgeMessages): Promise<void>;
    terminateConversation(): Promise<void>;
    destroy(): void;
    get sessionToken(): Five9Types.SessionToken | null;
    get conversationId(): string | null;
    get dataCenter(): Five9Types.DataCenter | undefined;
    get apiUrl(): string | undefined;
    get tenantId(): string | undefined;
    get tokenId(): string | undefined;
    get farmId(): string | undefined;
}
